'Bascom ATmega32, LCD, Memory und Tastenabfrage

$regfile = "m32def.dat"
$crystal = 11059200
$hwstack = 32
$swstack = 64
$framesize = 128
Baud = 9600

Declare Sub Irpulsein
Declare Sub Irpulsestart

Dim Pwma As Integer
Dim Pwmb As Integer

Dim T As Byte
Dim T1 As Byte
Dim T2 As Byte
Dim T3 As Byte
Dim T4 As Byte

Dim D1 As Byte
Dim D2 As Byte
Dim D3 As Byte
Dim D4 As Byte
Dim D5 As Byte
Dim D6 As Byte

Dim N As Byte

Config Timer1 = Pwm , Prescale = 8 , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down

'Config Timer0 = Timer , Prescale = 64
'Start Timer0

Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2

Initlcd
Cls
Locate 1 , 1
Lcd "IR Remote"

Waitms 500

Cls

S1 Alias Pind.2
S2 Alias Pind.3
S3 Alias Pind.6
S4 Alias Pind.7

Config Portd = &B00110000
Portd.2 = 1
Portd.3 = 1
Portd.6 = 1
Portd.7 = 1

Out1 Alias Portd.4
Out2 Alias Portd.5

Portc.7 = 1
Print "IR"




Do
      Do
        Irpulsestart
      Loop Until T > 100
      D1 = 0
      For N = 1 To 7
        Shift D1 , Left
        Irpulsein
        If T > 55 Then D1 = D1 + 1
      Next N

      D2 = 0
      For N = 1 To 6
        Shift D2 , Left
        Irpulsein
        If T > 55 Then D2 = D2 + 1
      Next N

      D3 = 0
      For N = 1 To 4
        Shift D3 , Left
        Irpulsein
        If T > 55 Then D3 = D3 + 1
      Next N

      D4 = 0
      For N = 1 To 6
        Shift D4 , Left
        Irpulsein
        If T > 55 Then D4 = D4 + 1
      Next N

      D5 = 0
      For N = 1 To 4
        Shift D5 , Left
        Irpulsein
        If T > 55 Then D5 = D5 + 1
      Next N

   'If D3 = 7 Then
      Print D1
      Print D2
      Print D3
      Print D4
      Print D5
      Print
      Locate 2 , 1
      Lcd D1
      Lcd " "
      Lcd D2
      Lcd " "
      Lcd D3
      Lcd " "
      Lcd D4
      Lcd " "
      Lcd D5
      Lcd "    "
      Pwm1a = D1
      Pwm1b = D2
      Waitms 100
 'End If
Loop



Sub Irpulsestart
  T = 0
  Do
    Waitus 10
    T = T + 1

  Loop Until Pinc.7 = 0
  T = 0
  Do
    Waitus 10
    T = T + 1
    If T > 250 Then Goto Fehler1
  Loop Until Pinc.7 = 1
Fehler1:

End Sub


Sub Irpulsein
  T = 0
  Do
    Waitus 10
    T = T + 1
    If T > 80 Then Goto Fehler2
  Loop Until Pinc.7 = 0
  T = 0
  Do
    Waitus 10
    T = T + 1
    If T > 250 Then Goto Fehler2
  Loop Until Pinc.7 = 1
Fehler2:
End Sub

End








